﻿#######################################################################
#Скрипт PowerShell для объединения GPX-файлов
#Работает с треками Strava, Endomondo, Amazfit Bip
#В общем случае должен сработать со схемой узлов gpx.trk.trkseg.trkpt
# https://t.me/electricbiker ⚡🚴‍♂️
#######################################################################

#по умолчанию файлы GPX берутся из папки, где лежит скрипт
#можно указать ниже любую папку вместо $PSScriptRoot или задавать ее параметром командной строки -Path
param (
	$Path = $PSScriptRoot
)

#удаление предыдущего объединенного трека, если имеется
If (Test-Path "$Path\out.gpx") {Remove-Item "$Path\out.gpx"}

#выборка GPX-файлов из папки | только сегодняшние | отсортированы по имени
$gpx = Get-ChildItem $Path *.gpx | Where-Object {$_.LastWriteTime -ge [datetime]::Today} | Sort-Object {$_.Name}
#первый файл (служит основой, в него добавляются точки из остальных файлов)
$gpxFirst = [xml] (Get-Content ($gpx | Select-Object -First 1).FullName)
#остальные файлы
$gpxN = $gpx | Select-Object -Skip 1

#перебор остальных файлов, извлечение точек и добавление в первый файл
foreach ($file in $gpxN)
{
  $gpxTemp = [xml](Get-Content $file.FullName)
  $elem = $gpxTemp.get_DocumentElement()
  foreach ($pt in $elem.trk.trkseg.trkpt) 
  {
    $in = $gpxFirst.ImportNode($pt, $true)
    $gpxFirst.gpx.trk.trkseg.AppendChild($in)
  }
}
#Сохранение объединенного трека в ту же папку
$gpxFirst.Save("$Path\out.gpx")
